#include "Ball.h"

Ball::Ball(const Vec2& in_pos, const Vec2& in_vel)
	:
	pos (in_pos),
	vel (in_vel)
{
}

void Ball::Update(float dt)
{
	pos += vel * dt;
}

void Ball::Draw(Graphics& gfx)
{
	SpriteCodex::DrawBall(pos, gfx);
}

RectF Ball::GetRect() const
{
	return RectF::FromCenter(pos, radius, radius);
}

void Ball::ReboundX()
{
	vel.x = -vel.x;
}

void Ball::ReboundY()
{
	vel.y = -vel.y;
}

void Ball::DoWallCollision(const RectF& walls)
{
	const RectF rect = GetRect();

	if (rect.left < walls.left) {
		ReboundX();
		pos.x -= (rect.left - walls.left);
	}
	else if (rect.right > walls.right) {
		ReboundX();
		pos.x -= (rect.right - walls.right);
	}

	if (rect.top < walls.top) {
		ReboundY();
		pos.y -= (rect.top - walls.top);
	}
	else if (rect.bottom > walls.bottom) {
		ReboundY();
		pos.y -= (rect.bottom - walls.bottom);
	}
}
