#pragma once

#include "SpriteCodex.h"
#include "Vec2.h"
#include "FrameTimer.h"
#include "RectF.h"

class Ball
{
public:
	Ball(const Vec2& in_pos, const Vec2& in_vel);
	void Update(float dt);
	void Draw(Graphics& gfx);
	RectF GetRect() const;
	void ReboundX();
	void ReboundY();
	void DoWallCollision(const RectF& walls);
private:
	static constexpr float radius = 7.0f;
	Vec2 pos;
	Vec2 vel;
};